--[[
Copyright (C) 2016  Neemys, ShadowTheAge

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

See <LICENSE.txt> for a copy of this license, or see <http://www.gnu.org/licenses/>
]]

--as old concentric cirle generation still add an autoplace for the platform and the new one doesn't, we need to re-add it to make old world still generate the same (terrain wise). Factorio have a complete different terrain generation if the autoplace for the platform change.
if(buildingplatform.config.platformGenerator == "concentric-circle") then

	-- Map generation control
	data:extend(
	{
	  {
		type = "noise-layer",
		name = buildingplatform.tileName
	  },
	  {
		type = "autoplace-control",
		name = buildingplatform.tileName,
		richness = false, 
		order = "c-a" --under ressources
	  },
	});

	data.raw["tile"][buildingplatform.tileName].autoplace = {
		control = "building-platform",
		sharpness = 0.919,--1854,
		coverage = 0.17, 
		starting_area_size = 10,
		--random_probability_penalty = .4,
		max_probability = 0,
		peaks = {
			-- control generation outside starting area, less frequent but bigger than starting area.
			{
				noise_layer = "building-platform",
				noise_octaves_difference = -1.5,
				noise_persistence = 0.3 + .1,
				starting_area_weight_optimal = 0,
				starting_area_weight_range = 0,
				starting_area_weight_max_range = 2,
				roughness = 1.5
			},
			-- control generation inside starting area.
			{
			  influence = 0.3,
			  starting_area_weight_optimal = 1,
			  starting_area_weight_range = 0,
			  starting_area_weight_max_range = 2,
			  roughness = 1.5
			},
			{
			  influence = 0.75,
			  noise_layer = "building-platform",
			  noise_octaves_difference = -2.4,
			  noise_persistence = 0.2,
			  starting_area_weight_optimal = 1,
			  starting_area_weight_range = 0,
			  starting_area_weight_max_range = 2,
			  roughness = 1.5
			},
			-- as tile can cover water, we need to block spawn below 0 elevation.
			{
				influence = 1e4, -- big number to be sure it have priority
				-- as max elevation is 5000 we could have wrote 2500 in each, but devs used 5000, there must be a reason....
				elevation_optimal = 5000,
				elevation_range = 5000,
				elevation_max_range = 5000,
			},
		},
	}


end
